//Marius Nicoli O(N^3)
#include <stdio.h>
#include <math.h>
#define DIM 1011

char A[DIM][DIM];

int L, C, i, j, M, R, maxim, sum, X, Y, dx, dy;
double dist;

inline int modul(int a) {
	return a > 0 ? a : -a;
}

inline int Maxim(int a, int b) {
	return a > b ? a : b;
}

inline int Minim(int a, int b) {
	return a < b ? a : b;
}

int main() {
	FILE *f = fopen("cerc.in","r");
	FILE *g = fopen("cerc.out","w");
	fscanf(f,"%d %d %d %d",&L, &C, &X, &Y);
	for (i=1;i<=L;i++) {
		fscanf(f,"%s",A[i]+1);
	}
	fclose(f);
	
	int M = (L > C ? L : C);
	
	maxim = -2000000000;
	
	for (R = 1; R <= 2*M; R++) {
		sum = 0;
		for (i=Maxim(X-R,1);i<=Minim(X+R,L);i++)
			for (j = Maxim(Y-R,1);j<=Minim(Y+R,C);j++) {
				
				if (i == X && j == Y)
					dist = 0;
				else
					if (i == X) {
						dist = 2*modul(j - Y) - 1;
					} else
						if (j == Y) {
							dist = 2*modul(i - X) - 1;
						} else {
							dx = 2*modul(i - X) - 1;
							dy = 2*modul(j - Y) - 1;
							dist = sqrt(dx*dx + dy*dy);
						}
				if (dist <= R) {
					if (A[i][j] == '1')
						sum++;
					else
						sum--;
				}
			}
		if (sum > maxim)
			maxim = sum;
	}
	fprintf(g,"%d\n",maxim);
	fclose(g);
	return 0;
}