//Marius Nicoli, 100P	O(N) + sigma*log(N)
#include <stdio.h>
#include <string.h>
#include <vector>
#include <algorithm>

#define DIM 3000010

using namespace std;

char V[DIM];
int F[130];
int D[130];
int A[26][26];
int Ales[130];
int Present[130];
int N, i, j, Max, pMax, start;
int First[26];
vector<int> L[26];
vector<int>::iterator it;

int main() {
	FILE *f =fopen("cmmstr.in","r");
	FILE *g =fopen("cmmstr.out","w");
	
	fscanf(f,"%s",V+1);
	fclose(f);

	N = strlen(V+1);
	
	for (i=1;i<=N;i++) {
		L[V[i]-'a'].push_back(i);
		Present[V[i]] = 1;
	}
	start = 1;
	for (i=0;i<26;i++)
		if (Present[i+'a'])
			First[i] = L[i][0];
	
	do{
		Max = 0;
		
		start = 3000010;
		for (i=0;i<26;i++)
			if (Present[i+'a'] && !Ales[i+'a']) {
				if (start > First[i])
					start = First[i];
			}
		
		for (i='a';i<='z';i++)
			for (j='a';j<='z';j++)
				if (j!=i)
					if (Present[i] && Present[j] && !Ales[i] && !Ales[j])
						if (First[i-'a'] < L[j-'a'][L[j-'a'].size()-1])
							A[i-'a'][j-'a'] = 1;
		
		
/*		
		for (i=start;i<=N;i++) {
			Present[V[i]] = 1;
			if (!Ales[V[i]]) {
				if (F[V[i]] == 0)
					F[V[i]] = i;
				for (j='a';j<='z';j++)
					if (F[j] && j!=V[i])
						A[j-'a'][V[i]-'a'] = 1;
			}
		}
*/
		for (i='a';i<='z';i++)
			for (j='a';j<='z';j++)
				if (A[i-'a'][j-'a'])
					D[i]++;
		for (i='a';i<='z';i++)
			if (D[i]>Max) {
				Max = D[i];
				pMax = i;
			}
		if (Max == 0)
			break;
		fprintf(g,"%c",pMax);
		//start = F[pMax]+1;
		Ales[pMax] = 1;
		Present[pMax] = 0;
		memset(A,0,sizeof(A));
		memset(D,0,sizeof(D));
		memset(F,0,sizeof(F));
		for (i=0;i<26;i++) {
			if (Present[i+'a'] && !Ales[i+'a']) {
				it = upper_bound(L[i].begin(),L[i].end(),First[pMax-'a']);
				First[i] = *it;
			}
		}
	} while (1);
	for (i='a';i<='z';i++)
		if (Present[i] && !Ales[i])
			fprintf(g,"%c",i);
	
	fclose(g);
	return 0;
}